dpkg-source(1)

NAMN
dpkg-source - Verktyg för att manipulera Debiankällkodspaket (.dsc)

SYNOPS
dpkg-source [flagga...] åtgärd

BESKRIVNING
dpkg-source packar och packar upp Debiankällkodsarkiv. Inga av dessa kommandon tillåter att flera flaggor kombineras till ett, och de tillåter inte att värdet på en flagga anges som ett separat argument.

KOMMANDON

-x filnamn.dsc [utdatakatalog]
    Extrahera ett källkodspaket. Ett argument som inte är en flagga måste anges, namnet på debiankällkodsstyrfilen (.dsc). Ett valfritt andra argument som inte är en flagga kan anges för att bestämma vilken katalog källkoden skall packas upp i, det får inte existera. Om du inte anger någon utdatakatalog extraheras källkodspaketet till en katalog som heter källkod-version i den aktuella arbetskatalogen. dpkg-source läser namnen på de övriga filer som ingår i källkodspaketet från styrfilen; de antas vara i samma katalog som .dsc-filen. Filerna i det extraherade paketet kommer att ha behörighet och ägare satta till det som kunde förväntas om filerna och katalogerna bara hade skapats - kataloger och körbara filer kommer ha 0777 och enkla filer 0666, båda modifierade av uppackarens umask; om föräldrakatalogen är setgid kommer de extraherade katalogerna också att vara det, och samtliga filer och kataloger kommer ärva dess gruppägarskap. Om källkoden använder ett annat format än standardformatet (gäller för närvarande alla format förutom "1.0"), kommer dess namn att lagras som debian/source/format så att det används som standard när källkodspaketet byggs på nytt.

-b katalog [formatspecifika-flaggor]
    Bygg ett källkodpaket. Det första argumentet som inte är en flagga tas som namn på katalogen som innehåller det debianiserade källkodsträdet (dvs. med underkatalogen "debian" och kanske ändringar på originalfilerna). Beroende på vilket källkodspaketformat som används för att bygga formatet kan ytterligare parametrar kanske godtas. dpkg-source kommer bygga källkodspaketet med det första format som fungerar från denna lista i denna ordning: formatet som anges med kommandoradsflaggan --format, formatet som anges i debian/source/format, "1.0". Standardvärdet "1.0" rekommenderas ej och kommer att tas bort en gång i framtiden, du bör alltid dokumentera det önskade källkodsformatet i debian/source/format. Se avsnittet FORMAT PÅ KÄLLKODSPAKET för en utförlig beskrivning av de olika källkodspaketformaten.

--print-format katalog
    Visa formatet som skulle användas för att bygga källkodspaketet om dpkg-source -b katalog skulle köras (under samma förhållanden och med samma parametrar).

--before-build katalog
    Kör motsvarande krok för källkodspaketformatet. Kroken anropas innan något från paketet byggs (dpkg-buildpakcage anropar det väldigt tidigt, till och med före debian/rules clean). Kommandot är idempotent och kan anropas flera gånger. Det är inte alla källkodsformat som implementerar något i den här kroken, och de som gör det förbereder oftast källkodsträdet för att byggas, till exempel genom att se till att Debianpatchar har applicerats.

--after-build katalog
    Kör motsvarande krok för källkodspaketformatet. Kroken anropas efter att allt från paketet byggts (dpkg-buildpakcage anropar det sist). Kommandot är idempotent och kan anropas flera gånger. Det är inte alla källkodsformat som implementerar något i den här kroken, och de som gör det använder den normalt för att återställa det som --before-build har gjort.

--commit [katalog] ...
    Spara ändringar i källkodsträdet som har packats upp i katalog. Kommandot kan ta ytterligare parametrar beroende på källkodsformatet. Ett fel kommer rapporteras för format där operationen inte har någon betydelse.

-h, --help
    Visar hjälpskärm och avslutar.

--version
    Visar version och avslutar.

ALLMÄNNA BYGGFLAGGOR

-ccontrol-fil
    Anger huvudkällkodsstyrfil som information skall läsas från. Standardvärde är debian/control. Om ett relativt sökvägsnamn anges tolkas det från källkodsträdets toppnivåkatalog.

-ländringsloggfil
    Anger ändringsloggsfil som information skall läsas från. Standardvärde är debian/changelog. Om ett relativt sökvägsnamn anges tolkas det från källkodsträdets toppnivåkatalog.

-Fändringsloggformat
    Anger format på ändringsloggen. Som standard läses formatet från en speciell rad nära slutet av ändringsloggen, eller så används Debians standardformat om ingen information hittas.

--format=värde
    Använd det givna formatet för att bygga källkodspaketet. Det överstyr inte ett eventuellt format som anges i debian/source/format.

-Vnamn=värde
    Ställer in en utdatasubstitueringsvariabel. Se deb-substvars(5) för en beskrivning av utdatasubstituering.

-Tsubstvars-fil
    Läs substitueringsvariabler från substvarfil; standardvärde är att inte läsa någon fil.Flaggan kan användas flera gånger för att läsa substitueringsvariabler från flera filer.

-Dfält=värde
    Ersätt eller lägg till ett fält i den genererade control-filen.

-Ufält
    Ta bort ett fält ur den genererade control-filen.

-Zkomprimering, --compression=komprimering
    Anger vilken komprimering som skall användas för de skapade filerna (tar-bollar och diffar). Observera att flaggan inte gör att befintliga tar-bollar packas om, utan enbart påverkar nya filer. Värden som stöds är: gzip, bzip2, lzma samt xz. gzip är förvalet. Stöd för xz finns bara från och med dpkg-dev 1.15.5.

-znivå, --compression-level=nivå
    Komprimeringsnivå att använda. Som med -Z påverkas bara filer som nyskapas. Värden som stöds är: 1 till 9, best (bäst) och fast (snabb). 9 är förval för gzip och bzip2, 6 för xz och lzma.

-i[reg.uttr], --diff-ignore[=reg.uttr]
    Du kan ange ett reguljärt uttryck i perlformat för att matcha filer som du vill skall filtreras ut ur listan över filer för diffen. (Listan skapas av ett find-kommando.) (Om källkodspaketet byggs som ett version 3-paket med ett VCS kan detta användas för att ignorera ändringar som inte har checkats in på de angivna filerna. -i.* kommer att ignorera samtliga.) -i ensamt aktiverar funktionen, med ett standardvärde som filtrerar ut styrfiler och kataloger från de flesta vanliga versionshanteringssystem, säkerhetskopior, växlingsfiler och Libtool-byggutdatakataloger. Endast ett reguljärt kan vara aktivt, om du anger flera -i-flaggor är det den sista på kommandoraden som gäller. Flaggan är mycket användbar för att utesluta extrafiler som kommer med i diffen, t.ex om du underhåller din källkod i ett versionshanteringssystem och vill använda en utcheckning för att bygga ett källkodspaket utan att ta med de ytterligare filer och det normalt innehåller (t.ex CVS/, .cvsignore, .svn/). Det förvalda reguljära uttrycket täcker redan in många av dessa, men om du ändrar det, kom ihåg att det som standard kan träffa alla delar av filnamnet. Så, om du träffa bara början av ett filnamn eller hela filnamn måste du själv lägga till de förankringar som är nödvändiga (t.ex '(^|/)', '($|/)').

--extend-diff-ignore=reg.uttr
    Det reguljära uttrycket i perlformat som angavs utökar standardvärdet för --diff-ignore och dess nuvarande värde (om satt). Det gör så genom att lägga till "|reg.uttry" efter standarduttrycket. Flaggan är nyttig för debian/source/options för att exkludera en del automatiskt genererade filer från skapandet av automatiska patchar.

-I[filmönster], --tar-ignore[=filmönster]
    Om flaggan anges kommer filnamnet att sändas vidare till tar(1):s --exclude-flagga när det anropas för att skapa en .orig.tar.gz eller .tar.gz-fil. Till exempel kommer -ICVS att hoppa över CVS-kataloger när tar.gz-filen skapas. Flaggan kan upprepas flera gånger för att lista flera filnamn som skall uteslutas. -i ensamt aktiverar funktionen, med ett standardvärde som filtrerar ut styrfiler och kataloger från de flesta vanliga versionshanteringssystem, säkerhetskopior, växlingsfiler och Libtool-byggutdatakataloger.

Observera: Även om de används till liknande ändamål, så har -i och -I väldigt olika syntax och semantik. -i kan endast anges en gång och tar ett perl-kompatibelt reguljärt uttryck, vilket matchas mot den kompletta relativa sökvägen för varje fil. -I kan anges flera gånger och tar ett filnamnssökmänster med skaljokertecken. Mönstret matchas mot den kompletta relativa sökvägen, men även individuellt mot varje komponent i sökvägen. Den exakta semantiken för tar:s --exclude-flagga är något komplicerad, se http://www.gnu.org/software/tar/manual/tar.html#wildcards för fullständig dokumentation. Förvalt reguljärt uttryck och sökmönster för de bägge flaggorna kan ses i utdata för --help-kommandot.

ALLMÄNNA UPPACKNINGSFLAGGOR

--no-copy
    Kopiera inte original-tarbollar i närheten av det uppackade källkodspaketet.

--no-check
    Kontrollera inte signaturer och kontrollsummor före uppackning.

--require-valid-signature
    Vägra packa upp källkodspaketet om det inte innehåller en OpenPGP-signatur som kan verifieras antingen med användarens trustedkeys.gpg-nyckelring, en av de säljarspecifka nyckelringarna, eller en av de officiella Debiannyckelringarna (/usr/share/keyrings/debian-keyring.gpg och /usr/share/keyrings/debian-maintainers.gpg).

FORMAT PÅ KÄLLKODSPAKET
Om du inte vet vilket källkodspaketformat du skall använda, bör du antagligen välja antingen "3.0 (quilt)" eller "3.0 (native)". Se http://wiki.debian.org/Projects/DebSrc3.0 för information om hur dessa format sätts i produktion i Debian.

  Format: 1.0
Ett källkodspaket i detta format består antingen av en .orig.tar.gz, förbunden med en .diff.gz, eller en ensam .tar.gz (i så fall anses paketet vara eget, "native"). Uppackning Att packa upp ett Debianeget paket innebär att packa upp den ensamma tarbollen i målkatalogen. Att packa upp ett icke-eget paket innebär att först packa upp .orig.tar.gz-filen och sedan genom att tillämpa patchen som finns i .diff.gz-filen. Tidsstämplarna för alla filer nollställs till den tidpunkt då källkodspaketet extraherades (vilket undviker tidsstämpelförskjutningar som kunde leda till problem när autogenererade filer patchas). Diffen kan skapa nya filer (hela debian-katalogen skapas på det sättet), men kan inte ta bort filer (tomma filer kommer lämnas kvar). Bygga Att bygga ett Debianeget paket innebär bara att skapa en ensam tarboll med källkodskatalogen. Att bygga ett icke-eget paket innefattar att extrahera original-tarbollen i en separat ".orig"-katalog och skapa .diff.gz-filen på nytt genom att jämföra källkodspaketets katalog med .orig-katalogen.

Byggflaggor (med -b):

Om ett andra argument som inte är en flagga anges skall det vara namnet på originalkällkodskatalogen eller -tarfilen eller den tomma strängen om paketet är Debianspecifikt och därför inte har några Debianiserings-diffar. Om inget andra argument anges kommer dpkg-source att leta efter originalkällkodstarfilen paket_uppströmsversion.orig.tar.gz eller originalkällkodskatalogen paket.orig beroende på -sX-flaggorna. -sa, -sp, -sk, -su och -sr skriver inte över befintliga tar-filer och kataloger. Om det önskas bör -sA, -sP, -sK, -sU och -sR anges i stället.

-sk Anger att den ursprungliga källkoden är en tar-fil, som standard paket_uppströmsversion.orig.tar.filändelse. Den kommer låta originalkällkodsfilen ligga kvar som en tarfil, eller kopiera den till den aktuella katalogen om den inte redan är där. Tarbollen kommer att packas upp i katalog.orig för att generera diffen.

-sp Som -sk, men tar bort katalogen igen efteråt.

-su Anger att originalkällkoden är en katalog, som standard paket-uppströmsversion.orig och att dpkg-source skall skapa ett nytt originalkällkodsarkiv från den.

-sr Som -su, men tar bort katalogen när den har använts.

-ss Anger att originalkällkoden finns både som en katalog och en tar-fil. Katalogen kommer att användas av dpkg-source för att skapa diffen, men tarfilen för att skapa .dsc-filen. Flaggan måste användas med tillförsikt - om katalogen och tarfilen inte stämmer överens kommer ett trasigt källkodsarkiv att skapas.

-sn Anger att dpkg-source inte skall leta efter något källkodsarkiv och att ingen diff skall skapas. Det andra argumentet, om det anges, måste vara den tomma strängen. Flaggan används för Debianspecifika paket som inte har en separat uppströmskällkod och därför inte har någon debianiseringsdiff.

-sa eller -sA
    Anger att originalkällkoden finns som en katalog eller en tarfil - det andra argumentet, om det anges, kan vara det ena eller det andra, eller den tomma strängen (motsvarar att använda -sn). Om en tarfil hittas kommer programmet att packa upp den för att skapa en diff och ta bort den efteråt (motsvarar -sp). Om en katalog hittas kommer den att packas för att skapa originalkällkoden och ta bort den efteråt (motsvarar -sn). Om båda hittas kommer dpkg-source att ignorera katalogen, och skriva över den om -sA angavs (detta motsvarar -sP) eller ge ett felmeddelande om -sa angavs. -sA är standard.

--abort-on-upstream-changes
    Processen misslyckas om den genererade diffen innehåller ändringar av filer utanför underkatalogen debian. Den här flaggan tillåts inte i debian/source/options, men kan användas i debian/source/local-options.

Extraheringsflaggor (med -x):

Oavsett kommer ett befintligt källkodsträd att tas bort.

-sp Används när originalkällkoden som extraheras (om sådan finns) skall lämnas kvar som en tarfil. Om den inte redan finns i den aktuella katalogen, eller om en befintlig men annan fil finns där, kommer den att kopieras dit. (Detta är standard.)

-su Packar upp originalkällkodsträdet.

-sn Försäkrar att originalkällkoden varken kopieras till en aktuella katalogen eller packas upp. Eventuella originalkällkodsträd som finns i den aktuella katalogen tas fortfarande bort.

Alla -sX-flaggor är ömsesidigt uteslutande. Om du anger mer än en kommer endast den sista att användas.

--skip-debianization
    Hoppas över att tillämpa debian-diffen ovanpå uppströmskällkoden.

  Format: 2.0
Även känt som wig&pen. Detta format rekommenderas inte för allmän användning, formatet "3.0 (quilt)" ersätter det. Wig&pen var den första specifikationen av en ny generation av källkodspaketformat. Beteendet för detta format är detsamma som för "3.0 (quilt)"-formatet, förutom att det inte använder en explicit förteckning patchar. Alla filer i debian/patches/ som motsvarar det Perl-reguljära uttrycket [\w-]+ måste vara giltiga patchar: de appliceras när paketet packas upp. När du bygger ett nytt källkodspaket kommer eventuella ändringar på uppströmskällkoden att lagras i en patch som kallas zz_debian-diff-auto.

  Format: 3.0 (eget)
Detta format är en utökning av det egna paketformatet som anges av 1.0-formatet. Det stöder alla komprimeringsmetoder och kommer att som standard ignorera alla VCS-specifika filer och kataloger, samt många temporärfiler (se standardvärdet som är knutet till flaggan -i i texten för --help).

  Format: 3.0 (quilt)
Ett källkodspaket i detta format innehåller åtminstone en original-tarboll (.orig.tar.ext, där ext kan vara gz, bz2, lzma eller xz) och en Debiantarboll (.debian.tar.ext). Den kan även innehålla ytterligare original-tarbollar (.orig-komponent.tar.ext). komponent kan endast innehålla alfanumeriska tecken och bindestreck ("-").

Uppackning

Huvud-originaltarbollen packas upp först, därefter packas alla ytterligare originaltarbollar upp i underkataloger med namn efter komponent-delen i sitt filnamn (eventuella redan befintliga kataloger ersätts). Debian-tarbollen packas sedan upp ovanpå källkodskatalogen efter att en redan befintlig debian-katalog har tagits bort först. Observera att debian-tarbollen måste bestå av en debian-underkatalog, men att den även kan innehålla binärfiler utanför den katalogen (se flaggan --include-binaries).

Alla patchar listade i debian/patches/debian.series eller debian/patches/series tillämpas sedan. Om den förstnämnda filen används och den sistnämnda inte existerar (eller är en symbolisk länk), kommer den senare att ersättas av en symbolisk länk till den första. Tanken är att göra det enklare att använda quilt till att hantera patchuppsättningen. Observera att, även om dpkg-source korrekt tolkar series-filer som använder explicita flaggor till patch-programmet (lagrade på kommandoraden efter patch-filnamnet och ett eller flera blanksteg), så ignoreras dessa flaggor och det förväntar sig att patchar kan tillämpas med flaggan -p1 till patch. Det kommer därför visa en varning sådana flaggor upptäcks, och bygget kommer troligen att misslyckas.

Patchar kan även ta bort filer, på ungfär samma sätt som quilt normalt fungerar.

Filen .pc/applied-patchers skapas om patchar tillämpades vid uppackningen.

Bygga

Alla original-tarbollar som finns i den aktuella katalogen packas upp i en temporär katalog med samma logik som i uppackningen, debian-katalogen kopieras över i den temporära katalogen och alla patchar, förutom den automatiska patchen (debian-changesversion eller debian-changes, beroende på --single-debian-patch) tillämpas. Temporärkatalogen jämförs därefter mot källkodskatalogen. Om diffen inte är tom misslyckas bygget, såvida inte --single-debian-patch eller --auto-commit använts, i vilket fall diffen lagras i den automatiska patchen. Om den automatiska patchen skapas/tas bort, läggs den till/tas bort från series-filen och från quilt-metadata. Eventuella ändringar på binärfiler kan inte representeras i en diff och kommer därmed att leda till ett felmeddelande, såvida inte paketansvariga medvetet väljer att inkludera den modifierade binärfilen i debian-tarbollen (genom att lista den i debian/source/include-binaries). Byggningen kommer även att misslyckas om binärfiler upptäcks i debian-underkatalogen, såvida de inte har vitlistats i debian/source/include-binaries. Den uppdaterade debiankatalogen, och listan över modifierade binärer, används sedan för att skapa debian-tarbollen. Den automatiskt genererade diff-filen innehåller inte ändringar för VCS-specifika filer eller för många temporära filer (se standardvärdet som är knutet till flaggan -i i texten för --help). Detta gäller speciellt katalogen .pc som används av quilt, katalogen kommer att ignoreras när den automatiska patchen skapas. Observera: dpkg-source --before-build (och -b) ser till att alla patchar som anges i seriefilen tillämpas så att paketbygget alltid har alla patchar tillämpade. Detta görs genom att hitta alla icke-tillämpade patchar (som anges i filen series men inte i .pc/applied-patches), och om den första patchen i listan kan tillämpas utan fel kommer samtliga att tillämpas. Flaggan --no-preparation kan användas för att slå av detta beteende.

Lagra ändringar

--commit [katalog] [patchnamn] [patch-fil]
    Skapar en patch som motsvarar de lokala ändringar som inte hanteras av quilt-patch-systemet och integrerar dem i patch-systemet under namnet patchnamn. Om namnet saknas kommer programmet be om ett interaktivt. Om patch-fil anges används den som patch som motsvarar de lokala ändringar som skall integreras. Detta är oftast användbart efter ett misslyckat bygge som skapat filen på förhand. När patchen är integrerad startas ett redigeringsprogram så att du kan ange metainformationen i patchhuvudet.

Byggflaggor

--allow-version-of-quilt-db=version
    Tillåt dpkg-source att bygga källkodspaketet om versionen av quilt-metadata är den som angavs, även om dpkg-source inte känner till den. Det betyder att den givna versionen av quilt-metadata är kompatibel med version 2 som dpkg-source för närvarande stöder. Versionen av quilt-metadata lagras i .pc/.version.

--include-removal
    Ignorera inte borttagna filer och ta med dem i den automatiskt genererade patchen.

--include-timestamp
    Ta med tidsstämpel i den automatiskt genererade patchen.

--include-binaries
    Lägg till alla modifierade binärer i debian-tarbollen. Lägg även till dem i debian/source/include-binaries: de kommer att läggas till som standard i följande byggen och du behöver inte längre ange den här flaggan.

--no-preparation
    Försök inte att förbereda byggträdet genom att tillämpa patchar som inte verkar ha tillämpas för närvarande.

--single-debian-patch
    Använd debian/patches/debian-changes istället för debian/patches/debian-changes-version som namn på den automatiska patch som genereras vid bygget. Denna flagga är speciellt nyttig när paketet hanteras i ett versionshanteringssystem och en patch inte kan skapas på ett pålitligt sätt. Den aktuella diffen mot uppströms lagras istället i en ensam patch. Flaggan bör anges i debian/source/local-options och följs av filen debian/source/local-patch-header som beskricer hur Debianändringarna bäst kan ses, till exempel i det versionshanteringssystem som används.

--create-empty-orig
    Skapa huvud-originaltarbollen som tom automatiskt om den saknas och om det finns supplement-originaltarbollar. Flaggan är tänkt att användas när källkodspaketet bara är en samling av flera uppströmsprogram och där det inte finns något "huvud"-program.

--unapply-patches
    Ta bort patchar i kroken --after-build. Du behöver oftast inte ange flaggan eftersom dpkg-source automatiskt tar bort patchar om de tillämpades i --before-build. Flaggan tillåts endast i debian/source/local-options så att alla genererade källkodspaket som standard har samma beteende.

--abort-on-upstream-changes
    Processen misslyckas om en automatisk patch har genererats. Flaggan kan användas för att se till att alla ändringar har lagrats undan korrekt i separata quilt-patchar innan källkodspaketet byggts. Flaggan tillåts inte i debian/source/options, men kan användas i debian/source/local-options.

--auto-commit
    Processen misslyckas inte om en automatisk patch har skapats, den läggs istället direkt in i quilt-serien.

Extraheringsflaggor

--skip-debianization
    Hoppas över att packa upp debian-tarbollen ovanpå uppströmskällkoden.

--skip-patches
    Applicera inte patchar i slutet av uppackningen.

  Format: 3.0 (skräddarsytt)
Detta formatet är speciellt. Det anger inte ett riktigt källkodspaketformat, utan kan användas för att skapa källkodspaket med godtyckliga filer.

Byggflaggor

Alla argument som inte är flaggor tas som filer som skall integreras i det skapade källkodspaketet. De måste finnas, och helst i aktuell katalog. Åtminstone en fil måste anges.

--target-format=värde
    Krävs. Anger det riktiga formatet på det genererade källkodspaketet. Den skapade .dsc-filen kommer innehålla detta värde i sitt Format-fält och inte "3.0 (custom)".

  Format: 3.0 (git)
Formatet är experimentellt.

Ett källkodspaket i detta format består av en ensam "bundle" från ett git-arkiv .git, vilket innehåller paketets källkod. Filen .gitshallow, som innehåller revisioner för grunda git-kloner, kan även förekomma.

Uppackning

"Bundle":n klonas som ett git-arkiv till målkatalogen. Om filen gitshallow finns installeras den som ".git/shallow" i det klonade git-arkivet.

Observera att det nya arkivet som standard kommer att ha samma gren utcheckad som den som var utcheckad i det ursprungliga källkodsträdet. (Typiskt "master", men kan vara vad som helst.) Eventuella andra grenar kommer också att vara tillgängliga, under "remotes/origin/".

Bygga

Innan uppackningen fortsätter kommer en del tester att utföras för att se till att vi inte har några ej ignorerade ej incheckade ändringar.

git-bundle(1) används för att generera en "bundle" från git-arkivet. Som standard tas alla grenar och taggar i arkivet med i "bundle":n.

Byggflaggor

--git-ref=ref
    Gör det möjligt att ange en git-referens som skall tas med i "bundle":n. Om den anges överstyr den standardbeteendet som är att ta med alla grenar och taggar. Kan anges flera gånger. ref kan vara namnet på en gren eller tagg som skall tas med. Den kan även vara vilken som helst annan parameter som kan sändas med till git-rev-list(1). För att, till exempel, endast ta med grenen "master", angänd --git-ref=master. För att ta med alla taggar och grenar, förutom grenen private, använd --git-ref=--all --git-ref=^private

--git-depth=antal
    Skapar en grund klon med en historik som är avhuggen vid det angivna antalet revisioner.

  Format: 3.0 (bzr)
Detta format är experimentellt. Det genererar en ensam tarboll som innehåller bzr-arkivet.

Uppackning

Tarbollen packas upp och bzr används sedan för att hämta ut den aktuella grenen.

Bygga

Innan uppackningen fortsätter kommer en del tester att utföras för att se till att vi inte har några ej ignorerade ej incheckade ändringar.

De VCS-specifika delarna av källkodskatalogen kommer därefter att kopieras över till en temporär katalog. Innan den temporära katalogen packas i en tarboll utförs viss städning för att spara plats.

VARNINGAR OCH FELMEDDELANDEN

  källkodsformat ej angivet i debian/source/format
Filen debian/source/format bör alltid finnas och ange det önskade källkodsformatet. För bakåtkompatibilitet antar formatet "1.0" om filen inte finns, men du bör inte förlita dig på detta: vid någon punkt i framtiden kommer dpkg-source att justeras så att det misslyckas om filen inte finns. Resonemanget bakom detta är att formatet "1.0" inte längre är det rekommenderade formatet, du bör normalt välja ett av de nyare formaten ("3.0 (quilt)", "3.0 (native)"), men dpkg-source gör inte detta automatiskt åt dig. Om du vill fortsätta använda det gamla formatet bör du ange det explicit genom att skriva "1.0" i debian/source/format.

  diffen modifierar följande uppströmsfiler
När du använder källkodsformatet "1.0" är det oftast inte någon bra idé att modifiera uppströmsfiler direkt eftersom ändringarna döljs och i huvudsak är odokumenterade i diff.gz-filen. Du bör istället spara dina ändringar som patchar i debian-katalogen och applicera dem när paketet skall byggas. För att undvika den här komplexiteten kan du även använda formatet "3.0 (quilt)" som låter dig göra det här automatiskt.

  kan inte representera ändringen för fil
Ändringar på uppströmsfiler sparas normalt som patchfiler, men inte alla ändringar kan representeras med patchar: de kan endast ändra innehållet i vanliga textfiler. Om du försöker ersätta en fil med något som har en annan typ (till exempel ersätta en vanlig fil med en symbolisk länk eller en katalog) får du det här felmeddelandet.

  den tomma filen fil som just skapats kommer inte representeras i diffen
Tomma filer kan inte skapas med patchfiler. Ändringen kommer därmed inte att sparas i källkodspaketet och du får en varning om det.

  exekveringsläge läge på fil kommer inte representeras i diffen

  specialläget läge på fil kommer inte representeras i diffen
Patchfiler beskriver inte läget på filer och ändrade lägen sparas inte i källkodspaketet. Den här varningen påminner dig om detta.

FILFORMAT

  debian/source/format
Filen innehåller på en ensam rad det format som skall användas för att bygga källkodspaketet (möjliga format beskrivs ovan). Varken ledande eller avslutande blanksteg tillåts.

  debian/source/include-binaries
Filen innehåller en förteckning över binärfiler (en per rad) som skall tas med i debian-tarbollen. Inledande och avslutande blanksteg tas bort. Rader som börjar med "#" är kommentarer och hoppas över. Tomma rader ignoreras.

  debian/source/options
Filen innehåller en lista över långa flaggor som automatiskt sätts in före kommandoradsflaggorna som anges i ett anrop til dpkg-source -b eller dpkg-source --print-format. Flaggor som --compression och --compression-level är passande att lägga in i den här filen.

Ange varje flagga på en egen rad. Tomma rader och rader som börjar med "#" ignoreras. Inledande "--" skall tas bort och korta flaggor är inte tillåtna. Blanksteg tillåts runt "="-tecknet och citattecken tillåts runt värdet. Här är ett exempel på en sådan fil:

  # låt dpkg-source skapa en debian.tar.bz2 med maximal komprimering
  compression = "bzip2"
  compression-level = 9
  # använd debian/patches/debian-changes som en automatisk patch
  single-debian-patch
  # ignorera ändringar i config.{sub,guess}
  extend-diff-ignore = "(^|/)(config.sub|config.guess)$"

Observera: format-flaggor tillåts inte i den här filen, du bör använda filen debian/source/format istället.

  debian/source/local-options
Precis som debian/source/options förutom att filen inte inkluderas i det genererade källkodspaketet. Det kan vara användbart för att spara ett val som gäller för paketansvariga eller VCS-systemet källkodspaketet hanteras i.

  debian/source/local-patch-header

  debian/source/patch-header
Friformstext som läggs in på toppen av den automatiskt genererade patchen i formaten "2.0" eller "3.0 (quilt)". local-patch-header tas inte med i det genererade källkodspaketet medan patch-header tas med.

  debian/patches/series
Listar alla patchar som måste tillämpas (i den givna ordningen) ovanpå uppströmskällkodspaketet. Inledande och avslutande blanksteg tas bort. Rader som börjar med "#" är kommentarer och ignoreras. Tomma rader ignoreras. De rader som är kvar inleds med filnamnet på en patchfil (relativt till debian/patches/-katalogen) upp till det första blankstegstecknet eller slutet på raden. Valfria flaggor till quilt kan följa fram till slutet av raden eller det första "#" som följer på ett eller flera blanksteg (vilket anger början på en kommentar fram till slutet av raden).

PROGRAMFEL
Tidpunkten på fältöverstyrning inträffar jämfört med inställning av vissa standardutdatafält är ganska förvirrad.

SE ÄVEN
dpkg-deb(1), dpkg(1), dselect(1).

FÖRFATTARE
Upphovsrättsskyddat © 1995-1996 Ian Jackson
Upphovsrättsskyddat © 2000 Wichert Akkerman
Upphovsrättsskyddat © 2008-2011 Raphaël Hertzog

Detta är fri programvara; se GNU General Public License version 2 eller senare för kopieringsvillkor. Det finns INGEN GARANTI.

ÖVERSÄTTNING
Peter Krefting och Daniel Nylander.